<!doctype html>
<html ng-app="app">
  <head>
    <title>My AngularJS App</title>
    <script src="https://ajax.googleapis.com/ajax/libs/angularjs/1.5.6/angular.min.js"></script>
    <script>
      angular.module('app', []).controller('homeController', ['$scope', function($scope) {

        $scope.sides = 6;
        $scope.faces = ['~','~','Success','Success','Clue','Clue'];
        $scope.numberOfDice = 3;
        $scope.results = [];

        $scope.getFaces = function() {
          if ($scope.faces.length != $scope.sides) {
            $scope.faces = new Array($scope.sides);
            for(var i = 0; i < $scope.sides; i++) {
              $scope.faces[i] = i + 1;
            }
          }
          return $scope.faces;
        }

        $scope.throw = function() {
          function roll() {
            return Math.floor((Math.random() * $scope.sides) + 1);
          }
          $scope.results = new Array($scope.numberOfDice);
          for (var i = 0; i < $scope.numberOfDice; i++) {
            $scope.results[i] = $scope.faces[roll() - 1];
          }
        };

      }]);
    </script>
    <style>
      body {
        font-family: 'Helvetica', sans-serif;
        background: #f3f6f9;
      }
      .group {
        text-align: center;
        margin: .2em;
        border: .2px solid #fff;
        padding: 1em;
        background: #f1f3f8;
      }
      .group.results {
        background: #fff;
      }
      .group div {
        margin: .2em 0;
      }
      label {
        display: inline-block;
        width: 4em;
      }
      .group .seperator {
        min-height: .5em;
      }
      span.result {
        font-weight: bold;
        font-size: 1.5em;
        margin: .2em 0;
        display: inline-block;
      }
      button {
        font-size: 1em;
        padding: 1em;
        border: .1em solid #999 !important;
        border-radius: .4em;
        background-color: #eee;
        font-size: .9em;
      }
      button.main {
        background-color: #fff;
      }
    </style>
  </head>
  <body ng-controller="homeController">

    <div class="group throw">
      <div><label>Sides:</label><input type="number" ng-model="sides"/></div>
      <div><label>Dice:</label><input type="number" ng-model="numberOfDice"/></div>
    </div>

    <div class="group results">
      <div>
        <button class="main" ng-click="throw()">Roll {{numberOfDice}} Dice</button>
        <button ng-click="results=[]">Clear</button>
      </div>
      <div ng-if="results.length" class="seperator"></div>
      <div ng-repeat="dice in results track by $index">
        <div><span class="result">{{dice}}</span></div>
      </div>
    </div>

    <div class="group setup">
      <div class="faces" ng-repeat="face in getFaces() track by $index">
        <div><label>Face {{$index + 1}}:</label><input type="text" ng-model="faces[$index]" /></div>
      </div>
    </div>

  </body>
</html>
